VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form frmCalibrate 
   Caption         =   "SBC488E Calibrate"
   ClientHeight    =   6255
   ClientLeft      =   3750
   ClientTop       =   3570
   ClientWidth     =   10890
   Icon            =   "frmCalibrate.frx":0000
   ScaleHeight     =   6255
   ScaleWidth      =   10890
   Begin VB.CommandButton cmdDigTest 
      Caption         =   "Digital Test"
      Height          =   375
      Left            =   840
      TabIndex        =   5
      Top             =   5400
      Width           =   2055
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Scan"
      Height          =   375
      Left            =   7440
      TabIndex        =   4
      Top             =   4200
      Width           =   1575
   End
   Begin VB.CommandButton cmdWriteCal 
      Caption         =   "Write Calibration to EEPROM"
      Height          =   615
      Left            =   5400
      TabIndex        =   3
      Top             =   4200
      Width           =   1815
   End
   Begin VB.CommandButton cmdCal 
      Caption         =   "Calibrate"
      Height          =   375
      Left            =   3480
      TabIndex        =   2
      Top             =   4200
      Width           =   1695
   End
   Begin VB.Timer caliTimer 
      Left            =   4320
      Top             =   4680
   End
   Begin VB.TextBox txtChannel 
      Height          =   285
      Left            =   3600
      TabIndex        =   1
      Text            =   "0"
      Top             =   3840
      Width           =   1455
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   3615
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   10335
      _ExtentX        =   18230
      _ExtentY        =   6376
      _Version        =   393216
   End
   Begin VB.Label Label3 
      Caption         =   "Label3"
      Height          =   255
      Left            =   4440
      TabIndex        =   7
      Top             =   5520
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Label2"
      Height          =   255
      Left            =   3120
      TabIndex        =   6
      Top             =   5520
      Width           =   855
   End
End
Attribute VB_Name = "frmCalibrate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const MAX_ADDRESS = 7
Dim rowname(12) As String
Const DIG_PAUSE = 25





Sub DelayMs(del As Integer)
    caliTimer.Interval = del
    caliTimer.Enabled = False

    caliTimer.Tag = "runnning"
        caliTimer.Enabled = True
    Do
        DoEvents
    
    Loop While caliTimer.Tag = "runnning"
End Sub
Private Sub caliTimer_Timer()
    caliTimer.Tag = ""
End Sub

Private Sub cmdCal_Click()
    channel = txtChannel.Text
    lo_cal_set = 0.5
    hi_cal_set = 2#
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    'CALIBRATE DAC AND ADC
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    '   Set and measure low point
        '   Set DAC and gain and offset to default
        Main.TMWControl1.address = "GPIB0::15"
        msg$ = "DAC " & Str(channel) & "," & Str(lo_cal_set) & ",1.0,0.0" & vbCr
        Main.TMWControl1.Output (msg$)
        
        '   Set ADC gain and offset to default
        msg$ = "ADC " & Str(channel) & ",1.0,0.0" & vbCr
        Main.TMWControl1.Output (msg$)
        
        '   Let DAC settle
        DelayMs (500)
        
        ' start SBC488E ADC
        msg$ = "ADC? " & Str(channel) & vbCr
        Main.TMWControl1.Output (msg$)
        
        ' read SBC488E ADC result
        result$ = ""
        Main.TMWControl1.Enter result$
        lo_adc = Val(result$)

        ' read Actual
        lo_cal_actual = get_Keithley(16)
        
        
    ''''''''''''''''''''''''''''''''''''''''''''''
    '   Set and measure high point
        Main.TMWControl1.address = "GPIB0::15"
        msg$ = "DAC " & Str(channel) & "," & Str(hi_cal_set) & ",1.0,0.0" & vbCr
        Main.TMWControl1.Output (msg$)
        
        '   Let DAC settle
        DelayMs (500)
        
        ' start SBC488E ADC
        msg$ = "ADC? " & Str(channel) & vbCr
        Main.TMWControl1.Output (msg$)
        
        ' read SBC488E ADC result
        result$ = ""
        Main.TMWControl1.Enter result$
        hi_adc = Val(result$)
        
        
        ' read Actual
        hi_cal_actual = get_Keithley(16)
    '''''''''''''''''''''''''''''''''''''''''''''
    ' Calculate calibrations
        dac_offset = lo_cal_set - lo_cal_actual
        dac_gain = hi_cal_set / (hi_cal_actual + dac_offset)
       
        adc_offset = lo_cal_actual - lo_adc
        'adc_gain = hi_adc / (hi_cal_actual + adc_offset)
        adc_gain = hi_cal_actual / (hi_adc + adc_offset)
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    '   Write calibration
        Main.TMWControl1.address = "GPIB0::15"
        
        msg$ = "DAC " & Str(channel) & "," & Format(hi_cal_set, "0.00000") & "," & Format(dac_gain, "0.00000") & "," & Format(dac_offset, "0.00000") & vbCr
        Main.TMWControl1.Output (msg$)
        
        msg$ = "ADC " & Str(channel) & "," & Format(adc_gain, "0.00000") & "," & Format(adc_offset, "0.00000") & vbCr
        Main.TMWControl1.Output (msg$)
        
     ''''''''''''''''''''''''''''''''''''''''''''''''''''
    '   Get DAC calibration
        Main.TMWControl1.address = "GPIB0::15"
        msg$ = "DAC? " & Str(channel) & vbCr
                DelayMs (100)
        Main.TMWControl1.Output (msg$)
            timerGPIB = 2
        result$ = "" 'tracks GPIB reply - see Timer1 function

        Main.TMWControl1.Enter result$
        MSFlexGrid1.Col = channel + 1
        MSFlexGrid1.Row = 1
        
        Do While InStr(result$, ",") <> 0
            comma = InStr(result$, ",")
            MSFlexGrid1.Text = Format(Val(Left(result$, comma)), "0.00000")
            MSFlexGrid1.Row = MSFlexGrid1.Row + 1
            result$ = Right(result$, Len(result$) - comma)
        
        Loop
        
     ''''''''''''''''''''''''''''''''''''''''''''''''''''
    '   Get ADC calibration
        msg$ = "ADC?" & Str(channel) & vbCr
                DelayMs (100)
        Main.TMWControl1.Output (msg$)
        result$ = "" 'tracks GPIB reply - see Timer1 function
                DelayMs (100)
        Main.TMWControl1.Enter result$

        
        For i = 0 To 2
            comma = InStr(result$, ",")
            If comma <> 0 Then
                MSFlexGrid1.Text = Format(Val(Left(result$, comma)), "0.00000")
                result$ = Right(result$, Len(result$) - comma)
            ElseIf result = "" Then
                MSFlexGrid1.Text = ""
            Else
            
                MSFlexGrid1.Text = Format(Val(result$), "0.00000")
                result = ""
            End If
            MSFlexGrid1.Row = MSFlexGrid1.Row + 1

        
        Next
        
        'Get Volt reading
        DelayMs (500)
        MSFlexGrid1.Text = Format(get_Keithley(16), "0.00000")

        

        
        

        
End Sub
Function test_data(pdata As Integer) As Integer
    If pdata < 8 Then
        test_data = 2 ^ pdata
    
    Else
        test_data = (Not (2 ^ (pdata - 8))) And 255
    
    End If

End Function

Function loopback(portout As Integer, portin As Integer) As Boolean
    Dim pdata As Integer
    
     loopback = True
    For pdata = 0 To 16
        Label3.Caption = pdata
        msg$ = "PORT:DATA " & Str(portout) & "," & Str(test_data(pdata)) & vbCr
        Main.TMWControl1.Output (msg$)
        DelayMs (DIG_PAUSE)
        
        '   Read it back
        msg$ = "PORT:DATA? " & Str(portin) & vbCr
        Main.TMWControl1.Output (msg$)
        DelayMs (DIG_PAUSE)
        ' read SBC488E ADC result
        result$ = ""
        Main.TMWControl1.Enter result$

        If Val(result$) <> test_data(pdata) Then
            'MsgBox ("Error ")
            loopback = False
            DoEvents
        End If
    Next pdata
End Function



Private Sub cmdDigTest_Click()
    Dim pdata As Integer
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    'DIGITAL TEST , DIRECTION REGISTERS
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    '   Set and measure low point
    '   Set DAC and gain and offset to default
    
    Main.TMWControl1.address = "GPIB0::15"
    For channel = 0 To 3
        Label2.Caption = channel
        For pdata = 0 To 16
            Label3.Caption = pdata
            msg$ = "PORT:DIR " & Str(channel) & "," & Str(test_data(pdata)) & vbCr
            Main.TMWControl1.Output (msg$)
            DelayMs (DIG_PAUSE)
            '   Set ADC gain and offset to default
            msg$ = "PORT:DIR? " & Str(channel) & vbCr
            Main.TMWControl1.Output (msg$)
            DelayMs (DIG_PAUSE)
            ' read SBC488E ADC result
            result$ = ""
            Main.TMWControl1.Enter result$
        
    
            ' read Actual
            If Val(result$) <> test_data(pdata) Then
                MsgBox ("Error testing direction register, port " & Str(channel) & ", data= " & result$ & " ,expected" & Str(pdata))
            End If
        Next pdata
    Next channel
    MsgBox ("Testing direction register PASSED")
        
        

    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    'DIGITAL TEST , DIRECTION REGISTERS
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Set Port 0 as output and read data on port 2
    'Set port 3 as output and read data on port 1
    
            
    msg$ = "PORT:DIR " & "0,0" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)

    msg$ = "PORT:DIR " & "3,0" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)
    
    msg$ = "PORT:DIR " & "1,255" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)
    
    msg$ = "PORT:DIR " & "2,255" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)

            
    MsgBox ("Install Loop Back connector now")
    
    Main.TMWControl1.address = "GPIB0::15"
    
    If (Not loopback(0, 2)) Then
        MsgBox ("error")
    End If
    
    If (Not loopback(3, 1)) Then
        MsgBox ("error")
    End If
    
    msg$ = "PORT:DIR " & "0,255" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)

    msg$ = "PORT:DIR " & "3,255" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)
    
    msg$ = "PORT:DIR " & "1,0" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)
    
    msg$ = "PORT:DIR " & "2,0" & vbCr
    Main.TMWControl1.Output (msg$)
    DelayMs (DIG_PAUSE)
        
    If (Not loopback(1, 3)) Then
        MsgBox ("error")
    End If
    
    If (Not loopback(2, 0)) Then
        MsgBox ("error")
    End If


    MsgBox ("Testing data loop back PASSED, remove jumper")
End Sub

Private Sub cmdWriteCal_Click()
        Main.TMWControl1.address = "GPIB0::15"
        msg$ = "CAL:PIC" & vbCr
        Main.TMWControl1.Output (msg$)

End Sub

Private Sub Command2_Click()
    For channel = 0 To 7
        Main.TMWControl1.address = "GPIB0::15"
        msg$ = "DAC? " & Str(channel) & vbCr
        Main.TMWControl1.Output (msg$)
            timerGPIB = 2
        result$ = "" 'tracks GPIB reply - see Timer1 function
        DelayMs (100)
        Main.TMWControl1.Enter result$
        MSFlexGrid1.Col = channel + 1
        MSFlexGrid1.Row = 1
        
        Do While InStr(result$, ",") <> 0
            comma = InStr(result$, ",")
            MSFlexGrid1.Text = Format(Val(Left(result$, comma)), "0.00000")
            MSFlexGrid1.Row = MSFlexGrid1.Row + 1
            result$ = Right(result$, Len(result$) - comma)
        
        Loop
        
        msg$ = "ADC?" & Str(channel) & vbCr
        Main.TMWControl1.Output (msg$)
            timerGPIB = 2
        result$ = "" 'tracks GPIB reply - see Timer1 function
        DelayMs (100)
        Main.TMWControl1.Enter result$

        
        For i = 0 To 2
            comma = InStr(result$, ",")
            If comma <> 0 Then
                MSFlexGrid1.Text = Format(Val(Left(result$, comma)), "0.00000")
                result$ = Right(result$, Len(result$) - comma)
            ElseIf result = "" Then
                MSFlexGrid1.Text = ""
            Else
            
                MSFlexGrid1.Text = Format(Val(result$), "0.00000")
                result = ""
            End If
            MSFlexGrid1.Row = MSFlexGrid1.Row + 1

        
        Next
        
        'Get Volt reading
        Main.TMWControl1.address = "GPIB0::16"
        'Main.TMWControl1.Initialize
        msg$ = "data?" & vbCr
        Main.TMWControl1.Output (msg$)
            timerGPIB = 2
        result$ = "" 'tracks GPIB reply - see Timer1 function
        DelayMs (100)
        Main.TMWControl1.Enter result$

        MSFlexGrid1.Text = Format(Val(result$), "0.00000")

        

        
        
    Next channel

End Sub

Private Sub Form_Load()
rowname(1) = "DAC Value"
rowname(2) = "DAC gain"
rowname(3) = "DAC offset"
rowname(4) = "ADC Value"
rowname(5) = "ADC gain"
rowname(6) = "ADC offset"
rowname(7) = "Keithley"
    MSFlexGrid1.Cols = 9

    MSFlexGrid1.Rows = MAX_ADDRESS + 1
    For r = 1 To MSFlexGrid1.Rows - 1

        MSFlexGrid1.Row = r
        MSFlexGrid1.Col = 0
        MSFlexGrid1.Text = Str(r) & "  " & rowname(MSFlexGrid1.Row)
    Next r
    For c = 1 To MSFlexGrid1.Cols - 1
        MSFlexGrid1.Row = 0
        MSFlexGrid1.Col = c

        MSFlexGrid1.Text = "Chan" & Str(c - 1)
                    MSFlexGrid1.ColWidth(c) = 1120
 
    Next c

            MSFlexGrid1.Row = 0
        MSFlexGrid1.Col = 0
                    MSFlexGrid1.ColWidth(0) = 1120


End Sub

Private Sub MSFlexGrid1_Click()
    txtChannel.Text = MSFlexGrid1.Col
End Sub
Private Sub cmdScan_click()


End Sub

